"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Sentry = __importStar(require("@sentry/node"));
const client_1 = __importDefault(require("@blued-core/client"));
let flag = true;
const EventCache = new Map();
const LoopSecond = 10;
const ExpireSecond = 60;
class ExceptionReportClient extends client_1.default {
    buildClient(key) {
        if (flag) {
            flag = false;
            const conf = this.conf.get(key);
            Sentry.init(Object.assign({ dsn: !this.isLocal && conf, debug: this.isLocal, beforeSend: (e, hints) => {
                    const error = getErrorKey(hints.originalException);
                    if (EventCache.has(error) && Date.now() - EventCache.get(error) < ExpireSecond * 1e3) {
                        return null;
                    }
                    else {
                        EventCache.set(error, Date.now());
                        return e;
                    }
                } }, this.option));
            // 处理缓存错误的有效期
            setInterval(() => {
                EventCache.forEach((v, k) => {
                    if (Date.now() - v >= ExpireSecond * 1e3) {
                        EventCache.delete(k);
                    }
                });
            }, LoopSecond * 1e3);
        }
        return {
            client: Sentry,
            clean() { },
        };
    }
}
exports.default = ExceptionReportClient;
function getErrorKey(e) {
    return typeof e === 'string' ? e : [e.name, e.message, e.stack].join(' ');
}
//# sourceMappingURL=index.js.map